/*
 * gpio.c
 *
 *  Created on: 29.08.2016
 *      Author: wn
 */


#include <msp430g2553.h>
#include <stdint.h>

#define GPIO_C
#include "gpio.h"
#undef GPIO_C



extern tPinCfg pinCfg[];


void gpioInitPins() {
  for (tPin p = PINS_FIRST; p < PINS_END; p += 1) {
    tPinCfg pin = pinCfg[p];
    if (pin.portId == PORT1) {
      P1DIR |= pin.bit;
      P1SEL &= ~pin.bit;
      P1SEL2 &= ~pin.bit;
    } else if (pin.portId == PORT2) {
      P2DIR |= pin.bit;
      P2SEL &= ~pin.bit;
      P2SEL2 &= ~pin.bit;
    }
    gpioSetPin(p, pin.defaultOut);
  }
}

void gpioSetPin(tPin p, tPinState v) {
  tPinCfg pin = pinCfg[p];
  if (v == HIGH) {
    if (pin.portId == PORT1) {
      P1OUT |= pin.bit;
    } else if (pin.portId == PORT2) {
      P2OUT |= pin.bit;
    }
  } else {
    if (pin.portId == PORT1) {
      P1OUT &= ~pin.bit;
    } else if (pin.portId == PORT2) {
      P2OUT &= ~pin.bit;
    }
  }
}

