/*
 * main.c
 *
 *  Created on: 29.08.2016
 *      Author: wn
 */

#include <msp430g2553.h>
#include <stdint.h>
#include <intrinsics.h>
#include <stdlib.h>

#include "gpio.h"
#include "time.h"
#include "display.h"
#include "displayMuxer.h"
#include "PontCoopScheduler.h"
#include "measure.h"


int main() {
  WDTCTL = WDTPW | WDTHOLD;

  // highest possible system clock
  DCOCTL = DCO0 | DCO1 | DCO2;
  BCSCTL1 = XT2OFF | RSEL0 | RSEL1 | RSEL2 | RSEL3;
  BCSCTL2 = 0;
  BCSCTL3 = 0;


  gpioInitPins();
  timeInit();
  schInit();

  // interrupts are required for delay function in displayInit();
  __enable_interrupt();
  displayInit(NULL);
  __disable_interrupt();

  measureInit(NULL);
  //	displayMuxerInit(NULL);


  schAdd(displayExec, NULL, 0, DISPLAY_CYCLE);
  schAdd(measureStartConversion, NULL, 0, MEASURE_CYCLE);
  //	schAdd(displayMuxerExec, NULL, 0, 500);

  __enable_interrupt();

  while (1) {
    schExec();
  }
}



